/*̧قDoxygenpɏĂ܂B*/
//! \file *********************************************************************
//!
//! \brief ̧قϳƂǗ܂B
//!
//! - ߲		: AVRpIAR EWAVRGNU GCC
//! - x޲	: ATmega32U4
//!
//! \author	Atmel Corporation	: http://www.atmel.com \n
//!			xFAQ			: http://support.atmel.no/
//!
//! ***************************************************************************

/* 쌠 (c) 2009, Atmel Corporation S\ς݁B
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. ATMEL̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳATMELAVRiƂ̊֌WłĕzĎgp邱Ƃł܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * ATMELɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂATMEL̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂATMELɐӔC
 * Ȃł傤B
 */

//_____ ݸٰ ____________________________________________________________

#include "config.h"
#include "conf_usb.h"

#include "mouse_task.h"
#include "usb_descriptors.h"

#include "lib_mcu/usb/usb_drv.h"
#include "lib_mcu/wdt/wdt_drv.h"
#include "lib_mcu/power/power_drv.h"
#include "lib_mcu/pll/pll_drv.h"
#include "lib_mcu/util/start_boot.h"
#include "lib_mcu/flash/flash_drv.h"
#include "lib_mcu/cal_inter_rc/cal_inter_rc.h"
#include "modules/usb/device_chap9/usb_standard_request.h"

//_____ ϸ ________________________________________________________________

//! @defgroup mouse_report_fill ϳ񍐔z𖞂߂ϸ
//! @{
#define Hid_mouse_report_up()			(g_hid_mouse_report[2]-=MOUSE_SPEED)
#define Hid_mouse_report_down()			(g_hid_mouse_report[2]+=MOUSE_SPEED)
#define Hid_mouse_report_left()			(g_hid_mouse_report[1]-=MOUSE_SPEED)
#define Hid_mouse_report_right()		(g_hid_mouse_report[1]+=MOUSE_SPEED)

#define Hid_mouse_report_scroll_up()	(g_hid_mouse_report[3]+=MOUSE_SPEED)
#define Hid_mouse_report_scroll_down()	(g_hid_mouse_report[3]-=MOUSE_SPEED)

#define Hid_mouse_report_click_left()	(g_hid_mouse_report[0] |= 0x01)
#define Hid_mouse_report_click_right()	(g_hid_mouse_report[0] |= 0x02)
#define Hid_mouse_report_click_middle()	(g_hid_mouse_report[0] |= 0x04)

#define Hid_mouse_report_reset()		(g_hid_mouse_report[0]=0,g_hid_mouse_report[1]=0,g_hid_mouse_report[2]=0,g_hid_mouse_report[3]=0)
//! @}

//! @defgroup mouse_board_interface ϳۂƂŊq߂ϸ
//! @{
#define Is_mouse_left_event()			Is_switch_3()
#define Is_mouse_right_event()			Is_switch_2()
#define Is_mouse_up_event()				Is_switch_1()
#define Is_mouse_down_event()			Is_switch_0()

#define Is_mouse_scroll_up_event()		FALSE
#define Is_mouse_scroll_down_event()		FALSE

#define Is_mouse_click_left_event()		Is_switch_6()
#define Is_mouse_click_middle_event()	Is_switch_5()
#define Is_mouse_click_right_event()	Is_switch_4()
//! @}

//_____ 錾 _______________________________________________________________

bit is_mouse_event(void);

Bool g_b_send_report;				//!< 񍐏׸ނɎgp
Bool g_b_send_ack_report;			//!< ACK񍐏׸ނɎgp
U8 g_hid_mouse_report[4];			//!< HIDϳ񍐊i[Ɏgp
//! SOF̌vƌvvɎgp
volatile U8 g_u8_cpt_sof;
volatile int g_int_cpt_cal_update;

//! ̊֐ϳƂŕKvƂʰ޳/ĳ܂B
//!
void mouse_task_init(void)
{
	// SOF
	g_u8_cpt_sof=0;
	Usb_enable_sof_interrupt();

	// ̪
	Switches_init();
	Leds_init();
	Led7_on();
	Led6_off();

	// nłACK񍐑o
	g_b_send_report      = FALSE;
	g_b_send_ack_report  = TRUE;

	// UZv평
	g_int_cpt_cal_update = 0;
}

//! USB HIDϳuϳۂq
//!
void mouse_task(void)
{
	if(!Is_device_enumerated())
		return;								// us

#if (USB_LOW_SPEED_DEVICE==DISABLE)
	// ߲Ċ荞ݎgƓgōƂv悷̂SOFgp܂B
	// ̌CPUԂ𓾂邱Ƃ܂B
	if(g_u8_cpt_sof<NB_IDLE_POLLING_SOF)
		return;								// xҋ@
	g_u8_cpt_sof=0;
#endif

	if(!g_b_send_report)
	{
		// o̕񍐂ȂAǐVK񍐂𖞂߂ϳۂ𒲍
		if(is_mouse_event())
		{
			// 񍐑o
			g_b_send_report = TRUE;
		}
	}

	if((!g_b_send_report)&&(!g_b_send_ack_report))
		return;								// o񍐂ACKȂ

	//** 񍐂܂ACKȂ΂Ȃ܂B
	Usb_select_endpoint(EP_MOUSE_IN);
	if(!Is_usb_write_enabled())
		return;								// ߲ċ󂫖

	Led6_on();
	if( g_b_send_report )
	{
		g_b_send_report = FALSE;
		// "د"񍐌̂ACKo
		g_b_send_ack_report = (0!=g_hid_mouse_report[0]);
	}
	else
	{
		Hid_mouse_report_reset();			// ACK񍐂߂ɕ񍐂ؾ
		g_b_send_ack_report  = FALSE;
	}
	// 񍐑o
	Usb_write_byte(g_hid_mouse_report[0]);
	Usb_write_byte(g_hid_mouse_report[1]);
	Usb_write_byte(g_hid_mouse_report[2]);
	Usb_write_byte(g_hid_mouse_report[3]);
	Usb_ack_in_ready();
	Led6_off();
}

//! ̊֐͊²̪𒲂ׂHIDϳ񍐂𖞂܂B
//!
//! @return TRUE	۔̏ꍇB̏ꍇAHIDϳ񍐂܂B
//! @return FALSE	ۂȂ̏ꍇB
//!
bit is_mouse_event(void)
{
	Hid_mouse_report_reset();

	// دے
	if(Is_mouse_click_left_event()) {
		Hid_mouse_report_click_left();
	}
	if(Is_mouse_click_middle_event()) {
		Hid_mouse_report_click_middle();
	}
	if(Is_mouse_click_right_event()) {
		Hid_mouse_report_click_right();
	}

	// ړے
	if (Is_mouse_left_event()) {
		Hid_mouse_report_left();
	}
	if (Is_mouse_right_event()) {
		Hid_mouse_report_right();
	}
	if (Is_mouse_up_event()) {
		Hid_mouse_report_up();
	}
	if (Is_mouse_down_event()) {
		Hid_mouse_report_down();
	}
	if (Is_mouse_scroll_up_event()) {
		Hid_mouse_report_scroll_up();
	}
	if (Is_mouse_scroll_down_event()) {
		Hid_mouse_report_scroll_down();
	}

	// 񍐒
	if((0==g_hid_mouse_report[0])
	&& (0==g_hid_mouse_report[1])
	&& (0==g_hid_mouse_report[2])
	&& (0==g_hid_mouse_report[3]))
	{
		return FALSE;						// ۂȂ
	}
	return TRUE;							// ۔
}

//! ̊֐͖SOFv𑝉܂B
//!
//! @verbatim
//! USBڰъJn(SOF)荞ݻٰ݂s܂(1ms)B
//! ԒxǗɗLp
//! @endverbatim
//!
void sof_action()
{
	g_u8_cpt_sof++;

}

//! ̊֐30bOSCCALlXV܂B
//!
//! @verbatim
//! 30b̓U̍Z
//! @endverbatim
//!
void update_osc_cal_task()
{
	g_int_cpt_cal_update++;
	if(g_int_cpt_cal_update > 3000)
	{
		g_int_cpt_cal_update = 0;
		calibrate_inter_osc(vcc_5);
	}
}

//! ̊֐͐؂ւ荞݂CPUܰ޳ݓɈڍs܂B
//!
//! @verbatim
//! ̊֐͈ꎞ~(Suspend)MꂽɎs܂B
//! @endverbatim
//!
void suspend_action(void)
{
#if (USB_REMOTE_WAKEUP_FEATURE == ENABLED)
	if (remote_wakeup_feature == ENABLED)
	{
		Switches_enable_it();
	}
	Led7_off();
	Enable_interrupt();
	Enter_power_down_mode();
	Led7_on();
#endif
}

#if (USB_REMOTE_WAKEUP_FEATURE == ENABLED)
//! ̊֐ܰ޳ݓCPU𔲂Đ؂ւ荞݂֎~܂B
//!
//! @verbatim
//! ̊֐͐؂ւ荞ݎ󂯎莞Ɏs܂B
//! @endverbatim
//!
#ifdef __GNUC__
ISR(PCINT0_vect)
#else
#pragma vector = PCINT0_vect
__interrupt void switch_event_int()
#endif
{
	Switches_disable_it();
	usb_generate_remote_wakeup();
}
#endif
