/*̧قDoxygenpɏĂ܂B*/
//! \file *********************************************************************
//!
//! \brief ADC\ݒƍŒዟdɊւ`܂݂܂B
//!
//! - ߲		: AVRpIAR EWAVRGNU GCC
//! - x޲	: ATmega32U4
//!
//! \author	Atmel Corporation	: http://www.atmel.com \n
//!			xFAQ			: http://support.atmel.no/
//!
//! ***************************************************************************

/* 쌠 (c) 2009, Atmel Corporation S\ς݁B
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. ATMEL̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳATMELAVRiƂ̊֌WłĕzĎgp邱Ƃł܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * ATMELɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂATMEL̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂATMELɐӔC
 * Ȃł傤B
 */#ifndef ADC_H
#define ADC_H

//******************************************************************************
// ADC\ݒ
//******************************************************************************

// IBAT

#if (TARGET_BOARD == MEGAU4EK)
  #define R_SHUNT_OHMS 1
  #define R1_OHMS 10		// ADC1,ADC0: R1*(R1 + R2)
  #define R2_OHMS 30
  #define VREF_I 246L		// IBAT(100{)pADCd
  #define VREF_V 2462L		// IBAT(1000{)pADCd
#endif

#if (TARGET_BOARD == BC101)
  #define R_SHUNT_OHMS 1
  #define R1_OHMS 13		// ADC1,ADC0: R1*(R1 + R2)
  #define R2_OHMS 10
  #define VREF_I 256L		// IBAT(100{)pADCd
  #define VREF_V 2560L		// IBAT(1000{)pADCd
#endif

#if (TARGET_BOARD == EVK527)
  #define R_SHUNT_OHMS 1
  #define R1_OHMS 13		// ADC1,ADC0: R1*(R1 + R2)
  #define R2_OHMS 10
  #define VREF_I 256L		// IBAT(100{)pADCd
  #define VREF_V 2560L		// IBAT(1000{)pADCd
#endif

#define ADC_GAIN 10		    // ADC=10{
#define ADC_ACCURACY 512L	// 8ޯĐx

// mVł̌ʁ~1000=(vref~100)(ADC~10)
#define I_SCALE_1		((R1_OHMS + R2_OHMS)*(VREF_I))
#define I_SCALE_2		(R_SHUNT_OHMS * R1_OHMS * ADC_ACCURACY)

#define VBAT_SCALE_1	(long)((R1_OHMS + R2_OHMS)*(VREF_V))
#define VBAT_SCALE_2	(long)(R1_OHMS * ADC_ACCURACY * 2)

//******************************************************************************
// Sϐ
//******************************************************************************
//cgs extern __eeprom unsigned char VBAT_RANGE;
extern unsigned char VBAT_RANGE;
extern volatile ADC_Status_t ADCS;

//******************************************************************************
// ֐^
//******************************************************************************
#ifdef __GNUC__
ISR(ADC_vect);
#else
#pragma vector = ADC_vect
__interrupt void ADC_ISR (void);
#endif

unsigned int ScaleU (unsigned int data);
unsigned int ScaleI (unsigned int data);
void ADC_Wait (void);
void ADC_Init (void);

#endif // ADC_H
